"""
    Xbim Flex Identity API 2.0

    Global management and user services for xbim Flex Tenants  # noqa: E501

    The version of the OpenAPI document: 2.0
    Contact: info@xbim.net
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from xbim_flex.identity.api_client import ApiClient, Endpoint as _Endpoint
from xbim_flex.identity.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from xbim_flex.identity.model.problem_details import ProblemDetails
from xbim_flex.identity.model.user_tenant import UserTenant


class RegistrationApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.id20_registration_acceptinvitation_post_endpoint = _Endpoint(
            settings={
                'response_type': (UserTenant,),
                'auth': [
                    'oauth2'
                ],
                'endpoint_path': "/id/2.0/registration/acceptinvitation",
                'operation_id': 'id20_registration_acceptinvitation_post',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'secret',
                ],
                'required': [],
                'nullable': [
                    'secret',
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'secret':
                        (str, none_type,),
                },
                'attribute_map': {
                    'secret': 'secret',
                },
                'location_map': {
                    'secret': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )

    def id20_registration_acceptinvitation_post(
        self,
        **kwargs
    ):
        """Accept invitation  # noqa: E501

        <span style='font-size: 17px;'>Summary:</span>Accept invitation.<br/>Accepts a user's invitation to join a Tenant.  Creates or updates a User account with the granted access rights.  See https://developers.google.com/recaptcha/docs/verify for details on reCAPTCA.<br/>Return Type: <b>UserTenant</b><br/><br/>  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.id20_registration_acceptinvitation_post(async_req=True)
        >>> result = thread.get()


        Keyword Args:
            secret (str, none_type): The secret supplied by email. [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            UserTenant
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_host_index'] = kwargs.get('_host_index')
        return self.id20_registration_acceptinvitation_post_endpoint.call_with_http_info(**kwargs)

